<?php

// This class displays options panel, addons, documentation links below the plugin information.

class BpvmMetaInfo
{

  public function __construct()
  {
    add_filter('plugin_row_meta', [$this, 'cbAdditionalMetaLinks'], null, 2);
  }

  public function cbAdditionalMetaLinks($links, $file)
  {

    if (strpos($file, BWL_PVM_PLUGIN_ROOT_FILE) !== false && is_plugin_active($file)) {

      // nt = 1 // new tab.

      $additionalLinks = [

        [
          'title' => esc_html__("Option Panel", "bwl-pro-voting-manager"),
          'url' => get_admin_url() . 'admin.php?page=bwl-pvm_option_panel',
        ],
        [
          'title' => "Addons",
          'url' => get_admin_url() . 'admin.php?page=bpvm-addons',
        ],
        [
          'title' => "Docs",
          'url' => 'https://xenioushk.github.io/docs-wp-plugins/bpvm/index.html',
          'nt' => 1
        ],
        [
          'title' => esc_html__("Support", "bwl-pro-voting-manager"),
          'url' => BPVM_SUPPORT_URL,
          'nt' => 1
        ],
        [
          'title' => esc_html__("Tutorials", "bwl-pro-voting-manager"),
          'url' => BPVM_YOUTUBE_PLAYLIST,
          'nt' => 1
        ]

      ];

      if (BPVM_VERIFIED != 1) {
        $additionalLinks[] =  [
          'title' => '<span class="dashicons dashicons-privacy"></span>' . esc_html__("Active License", "bwl-pro-voting-manager"),
          'url' => get_admin_url() . 'admin.php?page=bpvm-license',
          'class' => 'bwl_activation_meta_link'
        ];
      }

      $new_links = [];

      foreach ($additionalLinks as $alData) {

        $newTab = isset($alData['nt']) ? 'target="_blank"' : "";
        $class = isset($alData['class']) ? 'class="' . $alData['class'] . '"' : "";

        $new_links[] =  '<a href="' . esc_url($alData['url']) . '"  ' . $newTab . '  ' . $class . '>' . $alData['title'] . '</a>';
      }

      $links = array_merge($links, $new_links);
    }

    return $links;
  }
}

new BpvmMetaInfo();
