<?php

class BpvmAdminNotice
{

  public function __construct()
  {
    add_action('admin_notices', [$this, 'pluginVerficationNotice']);
    //ajax call to save user settings.
    add_action("wp_ajax_bpvm_set_notice_status",  [$this, 'saveUserNoticeSettings']);
  }

  public function getAdminNoticeLists()
  {

    // Key MUST BE Unique. to be unique.
    // is-dismissible = display a close icon.
    // Classes: notice-success, notice-error, notice-warning. notice-info
    // status: 0, 1 [1= notice closed by user, 0/empty=show the notice]

    $noticeLists = [

      [
        'noticeClass' => 'success',
        'msg' => '<span class="dashicons dashicons-megaphone bwl_plugins_notice_text--success"></span>Add an <strong class="bwl_plugins_notice_text--success bwl_plugins_notice_text--bold">additional layer of security</strong> checks to prevent <span class="bwl_plugins_notice_text--danger bwl_plugins_notice_text--bold">fraudulent voting attempts</span> originating from automated bots effectively. Try <a href="https://1.envato.market/recaptcha-addon" class="bwl_plugins_notice_text--danger bwl_plugins_notice_text--bold" target="_blank"><span class="dashicons dashicons-shield bwl_plugins_notice_text--danger"></span>Recaptcha Addon</a> now.',
        'key' => 'bpvm_recap_addon_prompt',
        'status' => get_option('bpvm_recap_addon_prompt')
      ],

      [
        'noticeClass' => 'success',
        'msg' => '<span class="dashicons dashicons-megaphone bwl_plugins_notice_text--success"></span><strong class="bwl_plugins_notice_text--success bwl_plugins_notice_text--bold"> Good News !</strong> We have added a <a href="' . BPVM_YOUTUBE_PLAYLIST . '" class="bwl_plugins_notice_text--danger bwl_plugins_notice_text--bold" target="_blank"><span class="dashicons dashicons-youtube bwl_plugins_notice_text--danger"></span> YouTube Tutorials Playlist</a> for <strong>' . BWL_PVM_PLUGIN_TITLE . '</strong> plugin.',
        'key' => 'bpvm_youtube_playlist_status',
        'status' => get_option('bpvm_youtube_playlist_status')
      ],

      [
        'noticeClass' => 'error',
        'msg' => '<span class="dashicons dashicons-lock bwl_plugins_notice_text--danger"></span> Please <a href="' . get_admin_url() . 'admin.php?page=bpvm-license" class="bwl_plugins_notice_text--danger bwl_plugins_notice_text--bold">activate your copy</a> of the plugin to unlock premium options and official support of <strong class="bwl_plugins_notice_text--bold">' . BWL_PVM_PLUGIN_TITLE . '</strong>.',
        'key' => 'bpvm_license_status',
        'status' => (BPVM_VERIFIED == 1) ? 1 : get_option('bpvm_license_status')
      ]

      // If the woocommerce addon not installed then prompt user to install it.

    ];

    return $noticeLists;
  }


  public function pluginVerficationNotice()
  {

    foreach ($this->getAdminNoticeLists() as $notice) {

      $status =  $notice['status'] ?? 0;

      if ($status != 1) {
        echo '<div class="notice notice-' . trim($notice['noticeClass']) . ' is-dismissible">
                  <p class="bwl_plugins_notice_text">' . trim($notice['msg']) . '</p>
                  <button utton type="button" class="notice-dismiss bpvm_remove_notice" data-key="' . $notice['key'] . '">
                  <span class="screen-reader-text">Dismiss this notice.</span>
                  </button>
                </div>';
      }
    }
  }

  public function saveUserNoticeSettings()
  {

    // Only update the option key.

    $key = trim($_POST['noticeKey']);
    update_option($key, 1); // 1= notice closed by user, 0/empty=show the notice

    $data = [
      'status' => get_option($key),
      'key' => $key
    ];

    echo json_encode($data);

    die();
  }
}

new BpvmAdminNotice();
