<?php

function bpvmRestrictCategoryWiseVoting($bpvm_share_btn, $postId, $pvm_msg_thanks = "")
{

  // Get all the logged in voted information.
  // ID PATTERN: 'pvm_cwvd_<user_id>_<cat_id>_<post_id>'

  $voteSubmitStatusData = [];
  $userId = 0;
  $catInfo = bpvmGetTheParentCategoryId($postId); // general topic. we will change that later.

  // Check the category status.

  if (empty($catInfo)) {
    $voteSubmitStatusData = [
      'status' => 1,
      'pvm_clear_counter' => 0,
      'msg' => esc_html__("This post must have a category for voting!", "bwl-pro-voting-manager")
    ];
  }

  if (is_user_logged_in()) :
    $current_user = wp_get_current_user();
    $userId = $current_user->ID;
  endif;

  // Get logged in users vote data
  $categoryWiseVoteData = get_option('pvm_category_wise_vote_data');

  // Unique key for each post vote.
  // @Pattern: pvm_cwvd_<user_id>_<cat_id>

  // $categoryWiseVoteId = 'pvm_cwvd_' . $userId . '_' . $catInfo['catId'] . '_' . $postId;
  $categoryWiseVoteId = 'pvm_cwvd_' . $userId . '_' . $catInfo['catId']; // fixed in version 1.3.9

  // Logged in users can not submit more than 1 vote.
  // Time count.

  $voteSubmitStatus = isset($categoryWiseVoteData[$userId]) && in_array($categoryWiseVoteId, array_keys($categoryWiseVoteData[$userId])) ? 1 : 0;

  // $bwl_pvm_options = get_option('bwl_pvm_options');

  // $pvm_max_vote_submission = (isset($bwl_pvm_options['pvm_max_vote_submission']) && is_numeric($bwl_pvm_options['pvm_max_vote_submission'])) ? $bwl_pvm_options['pvm_max_vote_submission'] : 1; // = 1 votes.
  $pvm_max_vote_submission = 1; // = 1 votes.

  // $timebeforerevote = (isset($bwl_pvm_options['pvm_vote_interval']) && is_numeric($bwl_pvm_options['pvm_vote_interval'])) ? $bwl_pvm_options['pvm_vote_interval'] : 120; // Default Interval = 2 hours  

  // $loggedInUserVoteData = get_user_post_vote_info($postId, $userId);

  // // Check Submission Count.

  // if ($loggedInUserVoteData['total_votes'] < $pvm_max_vote_submission) {
  //   $voteSubmitStatus = FALSE;
  // }

  // // Check Date Validity.

  // $now = time();
  // $time = strtotime($loggedInUserVoteData['last_vote_date']);

  // if (round(($now - $time) / 60) > $timebeforerevote) {
  //   $voteSubmitStatus = FALSE;
  // }

  if ($voteSubmitStatus) {

    //        echo "Information EXIST in Database";

    $voteSubmitStatusData = [
      'status' => 1,
      'pvm_clear_counter' => 0,
      'msg' => apply_filters('pvm_msg_cat_vote_exist', esc_html__("You are allowed to submit one vote for each category!", "bwl-pro-voting-manager"))
    ];
  } else {

    //        echo "NOT EXIST";
    $categoryWiseVoteData[$userId][$categoryWiseVoteId] = 'true';
    update_option('pvm_category_wise_vote_data', $categoryWiseVoteData);

    $voteSubmitStatusData = [
      'status' => 0, // You can submit vote,
      'pvm_clear_counter' => 1,
      'msg' => $pvm_msg_thanks . $bpvm_share_btn
    ];
  }

  return $voteSubmitStatusData;
}
