<?php

function bpvmPluginInfoPage()
{
    require_once 'views/plugin_info.php';
}

function bpvmPluginAddonsPage()
{
    require_once 'views/addons.php';
}

function getBpvmLicenseInfo()
{

    $bpvm_purchase_verified = get_option('bpvm_purchase_verified') ?? 0;
    $bpvm_purchase_info = get_option('bpvm_purchase_info') ?? [];

    $pluginLicenseData = [
        'title' => BWL_PVM_PLUGIN_TITLE,
        'status' => $bpvm_purchase_verified, // 1= active, 0=not active, 2=no license reqruired.
        'info' => $bpvm_purchase_info,
        'pluginId' => BPVM_CC_ID,
        'supportLink' =>  BPVM_SUPPORT_URL
    ];

    // echo "<pre>";
    // print_r($pluginLicenseData);
    // echo "</pre>";

    return $pluginLicenseData;
}


function bpvmPluginLicensePage()
{

    $pluginLicenseData = getBpvmLicenseInfo();
    require_once 'views/verify_license.php';
}


function bpvmPluginOptionsPage()
{

    $bpvm_options_menu_slug = 'bwl-pvm';

    $licenseActivationInfo = (BPVM_VERIFIED == 1) ? ['class' => 'activated', 'text' => esc_html__("ACTIVE", "bwl-pro-voting-manager")] : ['class' => 'inactive', 'text' => esc_html__("INACTIVE", "bwl-pro-voting-manager")];

    add_menu_page(
        esc_html__("Voting Manager Option Panel", "bwl-pro-voting-manager"),
        esc_html__("Voting Manager", "bwl-pro-voting-manager"),
        'manage_options',
        $bpvm_options_menu_slug,
        'bpvmPluginInfoPage',
        plugins_url(BWL_PVM_PLUGIN_ROOT . '/libs/images/bpvm_menu_icon.png')
    );

    $sub_pages = [
        [
            'page_title' => esc_html__("BWL Pro Voting Manager Addons", "bwl-pro-voting-manager"),
            'menu_title' => esc_html__("Plugin Addons", "bwl-pro-voting-manager"),
            'menu_slug' => 'bpvm-addons',
            'cb' => 'bpvmPluginAddonsPage'
        ],
        [
            'page_title' => esc_html__("License Page", "bwl-pro-voting-manager"),
            'menu_title' => esc_html__("Plugin License", "bwl-pro-voting-manager") . '<span class="bpvm-license-activation-tag ' . $licenseActivationInfo['class'] . '">' . $licenseActivationInfo['text'] . '</span>',
            'menu_slug' => 'bpvm-license',
            'cb' => 'bpvmPluginLicensePage'
        ]
    ];

    foreach ($sub_pages as $sub_page) {
        add_submenu_page(
            $bpvm_options_menu_slug,
            $sub_page['page_title'],
            $sub_page['menu_title'],
            'manage_options',
            $sub_page['menu_slug'],
            $sub_page['cb']
        );
    }
}

add_action('admin_menu', 'bpvmPluginOptionsPage');
