<div class="wrap" id="bpvm-product-license">

  <h2><?php echo $pluginLicenseData['title'] . " " .  esc_html__("License Page", "bwl-pro-voting-manager"); ?></h2>

  <div id="loader"></div>

  <?php if ($pluginLicenseData['status'] == 2) { ?>

    <p class="developer-info">
      <?php esc_html_e("No license activation is required!", "bwl-pro-voting-manager") ?>
    </p>

  <?php } elseif ($pluginLicenseData['status'] == 0) { ?>
    <div class="license_form_container">
      <h4>
        <?php esc_html_e("In order to unlock premium options and official support of", "bwl-pro-voting-manager") . $pluginLicenseData['title'] ?>,
        <?php esc_html_e("you need to activate your copy of the plugin.", "bwl-pro-voting-manager") ?>

      </h4>
      <h3><?php esc_html_e("Add Plugin Purchase Code:", "bwl-pro-voting-manager") ?></h3>
      <form action="#" id="bpvm_verify_purchase">
        <input type="text" value="" name="purchase_code" id="purchase_code" placeholder="<?php esc_html_e("Purchase code", "bwl-pro-voting-manager") ?>">
        <input type="submit" value="<?php esc_html_e("Active License", "bwl-pro-voting-manager") ?>" id="verify" class="button button-primary">
      </form>

      <p>
        <strong><?php esc_html_e("Do you need any help?", "bwl-pro-voting-manager") ?> <a href="<?php echo $pluginLicenseData['supportLink']; ?>" target="_blank">
            <?php esc_html_e("Send a message", "bwl-pro-voting-manager") ?></a></strong>.
      </p>
    </div>
  <?php } elseif ($pluginLicenseData['status'] == 1) { ?>

    <div class="license_info_container">
      <h3><?php esc_html_e("License Information:", "bwl-pro-voting-manager") ?></h3>

      <?php

      $purchaseInfo = $pluginLicenseData['info'];
      $supportRenwalInfo = getRenewalDaysLeft($purchaseInfo['supported_until']);
      $supportRenwalClass = $supportRenwalInfo['msg'] == 1 ? "support-valid" : "support-expired";

      ?>

      <ul class="plugin_purchase_info">
        <li><strong><?php esc_html_e("License Type", "bwl-pro-voting-manager") ?>: </strong>
          <span><?php echo $purchaseInfo['license'] ?></span>
        </li>
        <li><strong><?php esc_html_e("Purchase Date", "bwl-pro-voting-manager") ?>: </strong>
          <span><?php echo bwlBeautifyDate($purchaseInfo['sold_at']) ?></span>
        </li>
        <li><strong><?php esc_html_e("Support Until", "bwl-pro-voting-manager") ?>: </strong>
          <span><?php echo bwlBeautifyDate($purchaseInfo['supported_until']) ?></span>
          <span class="<?php echo $supportRenwalClass ?>"><?php echo $supportRenwalInfo['msg']; ?></span>
        </li>
      </ul>

      <button id="bpvm_remove_license" class="button button-primary" data-verify_hash="<?php echo $purchaseInfo['verify_hash'] ?>"><?php esc_html_e("Remove License", "bwl-pro-voting-manager") ?></button>

      <?php if (getRenewalDaysLeft($purchaseInfo['supported_until'])['status'] == 0) : ?>
        <a href="<?php echo BPVM_CC_URL ?>" class="button button-primary" target="_blank"><?php esc_html_e("Renew Support Period", "bwl-pro-voting-manager") ?></a>
      <?php endif; ?>

    </div>

  <?php

  } else {
    // Do Nothing
  }

  // It will display all the page

  $licenseFaqs = [
    [
      'ques' => "How to download the purchase code?",
      'ans' => "Check <a href=' https://bluewindlab.net/knowledgebase/general/where-i-can-get-the-purchase-code/' target='_blank'>this article</a> for step-by-step instructions."
    ],

    [
      'ques' => "I downloaded the plugin from Envato Elements. How can I get the purchase code?",
      'ans' => "Unfortunately, you can not. However, you can use all the features of the plugin without issue. The only exception is that we do not provide customer support if you download the plugin from Envato Elements."
    ],
    [
      'ques' => "Can I get customer support If I download the plugin from Envato Elements?",
      'ans' => "No. To get the author's premium support, please consider purchasing the plugin from <a href='" . BPVM_CC_URL . "' target='_blank'>CodeCanYon</a>."
    ],
    [
      'ques' => "My six-month premium support period has expired. How to extend it?",
      'ans' => "Follow <a href='" . BPVM_CC_URL . "' target='_blank'>this link</a> and click the Renew Support button."
    ]
  ];


  ?>


  <div class="license_faq_container">
    <h3 class="license_faq_title">License F.A.Q</h3>
    <ul class="license_faqs">

      <?php foreach ($licenseFaqs as $faq) : ?>
        <li>
          <p class="question">
            <?php echo $faq['ques'] ?>
          </p>
          <p class="answer">
            <?php echo $faq['ans'] ?>
          </p>
        </li>
      <?php endforeach; ?>

    </ul>
  </div>

</div>