<?php

add_action('wp_ajax_bwl_pvm_save_post_data', 'bwl_pvm_save_post_data');
add_action('wp_ajax_nopriv_bwl_pvm_save_post_data', 'bwl_pvm_save_post_data');

/*--- Add Feedback Message ---*/

function bwl_pvm_save_post_data()
{

  $post_id = $_REQUEST['post_id'];

  if (empty($_REQUEST) || !wp_verify_nonce($_REQUEST['name_of_nonce_field'], 'name_of_my_action')) {

    $status = array(
      'pvm_feedback_status' => 0
    );
  } else {

    // We are going to create an unique ID

    $pvm_feedback_message_unique_id = 'pvm_feedback_list_' . $post_id; // so idea is we are going to add post id after vairable name

    $prev_pvm_feedback_message = (get_post_meta($post_id, $pvm_feedback_message_unique_id, true) == "") ?  array() : get_post_meta($post_id, $pvm_feedback_message_unique_id, true);

    $prev = $prev_pvm_feedback_message;

    $prev_pvm_feedback_message[] = wp_strip_all_tags($_REQUEST['feedback_message_box']);

    update_post_meta($post_id, $pvm_feedback_message_unique_id, $prev_pvm_feedback_message, $prev);

    //Send Email to administrator.

    $pvm_feedback_email_status = TRUE; // Initally We send email when user post a new faq.

    $bwl_pvm_options = get_option('bwl_pvm_options');

    if (isset($bwl_pvm_options['pvm_feedback_email_status']) && $bwl_pvm_options['pvm_feedback_email_status'] == 0) {

      $pvm_feedback_email_status = FALSE;
    }

    if ($pvm_feedback_email_status == TRUE) {

      $to =  get_bloginfo('admin_email');

      if (isset($bwl_pvm_options['pvm_feedback_admin_email']) && $bwl_pvm_options['pvm_feedback_admin_email'] != "") {

        $to =  $bwl_pvm_options['pvm_feedback_admin_email'];
      }

      $email = "user@email.com";
      $subject = apply_filters('pvm_feedback_subject', esc_html__('New Feedback Submitted!', "bwl-pro-voting-manager"));
      $edit_faq_url = get_admin_url() . "post.php?post&#61;$post_id&#38;action&#61;edit";

      $pvm_feedback_email_header = "<p>" . esc_html__("Hello Administrator", "bwl-pro-voting-manager") . ",<br>" . esc_html__("A new Feedback has been submitted by a user.", "bwl-pro-voting-manager") . "</p><hr />";
      $pvm_feedback_email_footer = "<p><strong>" . esc_html__("Review Feedback", "bwl-pro-voting-manager") . ":</strong> " . $edit_faq_url . "<br>" . esc_html__("Thank You!", "bwl-pro-voting-manager") . "</p>";

      $body = $pvm_feedback_email_header;
      $body .= "<p><blockquote>" . wp_strip_all_tags($_REQUEST['feedback_message_box']) . "</blockquote></p>";
      $body .= $pvm_feedback_email_footer;

      $headers[] = "From: " . apply_filters('pvm_feedback_header', esc_html__('New Feedback', "bwl-pro-voting-manager")) . " <$email>";

      add_filter('wp_mail_content_type', 'bwl_pvm_set_html_content_type');

      wp_mail($to, $subject, $body, $headers);

      remove_filter('wp_mail_content_type', 'bwl_pvm_set_html_content_type');
    }

    $status = array(
      'pvm_feedback_status' => 1
    );
  }

  echo json_encode($status);

  die();
}

/**
 * @Description: Add A filter for sending HTML email.
 * @Created At: 08-04-2013
 * @Last Edited AT: 30-06-2013
 * @Created By: Mahbub
 **/

function bwl_pvm_set_html_content_type()
{
  return 'text/html';
}
