<?php



/**
 * 
 * @param int $postId
 * @param int $userId
 * 
 * @return array ['total_votes'=> 10, 'last_vote_date'=> '2023-10-21']
 */
function get_user_post_vote_info($postId = 0, $userId = 0)
{

  global $wpdb;
  $bpvm_voting_data_table = BPVM_VOTE_DATA_TABLE; // for deatils. each day info.

  $vars = [$postId, $userId, date("Y-m-d")];

  $con_mv_post_filters = "";

  $sql = $wpdb->prepare("SELECT ID, vote_date FROM {$bpvm_voting_data_table} 
                    WHERE postid = %d 
                    AND user_id = %d 
                    AND DATE(vote_date) = %s 
                    " . $con_mv_post_filters . "
                    ORDER BY vote_date DESC", $vars);

  $result = $wpdb->get_results($sql, ARRAY_A);

  $userVoteData = [];

  if (!empty($result)) {

    $userVoteData['total_votes'] = count($result);
    $userVoteData['last_vote_date'] = $result[0]['vote_date'];
  } else {
    $userVoteData['total_votes'] = 0;
    $userVoteData['last_vote_date'] = "";
  }

  return $userVoteData;
}
